library MyTempDir;

uses SysUtils;

{$E .plg}
{$R *.res}

type
  //  (     ,
  //  GET  POST.       )
  TPlgCallBack=procedure(const AText: PChar);
  //  GET
  TURLGet = procedure (const URL: PChar; const CallBack: TPlgCallBack); stdcall;
  //  POST,   -    
  // : _1=_1 #10 _2=_2  
  TURLPost = procedure (const URL, Data: PChar; const CallBack: TPlgCallBack); stdcall;
  TSetRetResult=procedure(const AText: PChar); stdcall;
  //    
  TSaveToLog = procedure (const AText: PChar); stdcall;
  //  (   Dialogs)
  TShowMsg = function (const AText: PChar; const mode: Byte): Integer; stdcall; //0 - info, 1 - confirmation, 2 - Error
  //    .    
  TSaveToFile = procedure (const AName, AContent: PChar); stdcall;

var URLGet: TURLGet;
    URLPost: TURLPost;
    FDebug: Boolean;
    WorkDir: AnsiString;
    SaveToLog: TSaveToLog;
    SaveToFile: TSaveToFile;
    ShowMsg: TShowMsg;
    SetRetResult: TSetRetResult;

    RezFromMainApp: AnsiString;

//-    MyTempDir -----------------------------------------------------------------------    

function Hex2Dec(const S: string): Longint;
var
  HexStr: string;
begin
  if Pos('$', S) = 0 then HexStr := '$' + S
  else HexStr := S;
  Result := StrToIntDef(HexStr, 0);
end;

function SevBit2WIN(const mm: AnsiString): AnsiString;
const  HexArr = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','a','b','c','d','e','f'];
var i,n: Integer;
begin
  Result:='';
  if mm='' then exit;
  SetLength(Result,length(mm));
  i:=1;
  n:=1;
  repeat
    if ((mm[i]='=') or (mm[i]='%') or
       ((i>1) and (mm[i-1]='\') and (mm[i]=''''))) and
       (mm[i+1] in HexArr) and
       (mm[i+2] in HexArr) then begin
          if mm[i]='''' then dec(n);
          Result[n]:=chr(Hex2Dec(copy(mm,i+1,2)));
          inc(i,2);
          inc(n);
    end else begin
      // =#13  =#10 -    
      if (mm[i]='=') and (i<length(mm)) and ((mm[i+1]=#10) or (mm[i+1]=#13)) then
        inc(i,2)//  
      else begin
        Result[n]:=mm[i];
        inc(n);
      end;
    end;
    inc(i);
  until i>length(mm);
  Result:=copy(Result,1,n-1);
end;




//-----------------------------------------------------------------------------------------------
//    --------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

//  ,    1  
// GET  POST 
procedure PlgCallBack(const AText: PChar);
begin
  RezFromMainApp:=StrPas(AText);
end;

// .   - ,  
// .  Get
function Get(const URL: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLGet(PChar(URL), @PlgCallBack);
  Result:=RezFromMainApp;
end;

// .   - ,   POST,
//   .  Post
function Post(const URL, Data: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLPost(PChar(URL), PChar(Data), @PlgCallBack);
  Result:=RezFromMainApp;
end;

//    .
procedure PlgInit(const funcGet, funcPost, funcSaveToLog, funcShowMsg, funcSaveToFile, funcRetResult: Pointer; const Debug: byte; const AWorkDir: PChar); stdcall;
begin
  @URLGet:=funcGet;             //   GET
  @URLPost:=funcPost;           //   POST
  @SaveToLog:=funcSavetoLog;    //   SaveToLog
  @SaveToFile:=funcSaveToFile;  //   SaveToFile
  @ShowMsg:=funcShowMsg;        //   ShowMsg
  @SetRetResult:=funcRetResult;

  FDebug:=Debug=1;              //  /
  WorkDir:=StrPas(AWorkDir);    //  (     )

  SetRetResult('mytempdir.com');//   . .
                                //  URL    -  
                                //   .   
end;

//  -    ""      
//      -  "http://sr1.mytempdir.com/116387"
//  ,     :
//%deleted% -     
//%notfound% -      ( ?)
//    -         
//  5  (      30   
//    ,   ""      )
procedure PlgGetDirectLink(const MyTempDirLnk: PChar); stdcall;
var s: AnsiString;
    n: Integer;
begin
  s:=Get(MyTempDirLnk);
  if s='' then exit;

  //  
  if pos('404 Not Found',s)>0 then begin
    SetRetResult('%notfound%'); //     
    exit;
  end;

  if FDebug then
    SaveToFile(PChar(WorkDir+'MyTempDir.html'),PChar(s));

  if pos('file was removed',s)>0 then begin
    SetRetResult('%deleted%');
    exit;
  end;

  if pos('Wrong file ID.',s)>0 then begin
    SetRetResult('%notfound%');
    exit;
  end;

  n:=pos('.innerHTML = unescape(''',s);
  if n=0 then exit;
  inc(n,23);//  
  s:=copy(s,n,MaxInt);

  n:=pos(''')',s);
  if n=0 then exit;
  s:=SevBit2WIN(copy(s,1,n-1));

  n:=pos('http://sr',s);
  if n=0 then exit;
  s:=copy(s,n,MaxInt);

  n:=pos('">',s);
  if n=0 then exit;

  s:=copy(s,1,n-1);

  SetRetResult(PChar(s));
end;

//   
procedure PlgDestroy; stdcall;
begin
  @URLGet:=nil;
  @URLPost:=nil;
end;

exports
  PlgInit,
  PlgGetDirectLink,
  PlgDestroy;

begin
end.
 
